;================================================
;	LIGHT CYCLE E500
;	ver 1.01
;	for XASM 1.3x/1.4x
;	2006.02-
;	by choikyun
;================================================



	org	0bec00h
	scope_on
	pre_off

	include DEF.INC



;================================================
;	萔
;================================================
MARK_SPACE:	equ	0	;
MARK_LINE:	equ	1	;@
MARK_COM:	equ	2	;COM
MARK_COM2:	equ	3	;COM2
MARK_BLOCK:	equ	4	;ubN
MARK_FLAG:	equ	5	;
MARK_POINT:	equ	6	;|C^[iC擪j

MAX_FLAG:	equ	4	;̐
MAX_BLOCK:	equ	20	;őubN
MAX_COM:	equ	3	;G̐
MAX_LEVEL:	equ	6	;ő僌x
LEVEL_STEP:	equ	3	;Xs[hAbvݒl

STOP_COUNT_DEF:	equ	6	;~
BONUS:		equ	030h	;{[iX300_

MY_DIREC_DEF:	equ	1	;@ړftHg:E
LINE_SPEED_DEF:	equ	23	;@ړxftHg
DEMO_SPEED:	equ	10	;fpړxftHg
ANIME_WAIT_DEF:	equ	20	;Aj[VԊu

WIN:		equ	0000_0010;Q[I[o[F
LOSE:		equ	0000_0001;Q[I[o[F
	;ړ
UP:		equ	0
RIGHT:		equ	1
DOWN:		equ	2
LEFT:		equ	3
	;LN^
CHR_SIZE:	equ	4
	;tB[h}bv
MAP_WIDTH:	equ	32
MAP_HEIGHT:	equ	10
	;XN[obt@
SCREEN_WIDTH:	equ	128
SCREEN_HEIGHT:	equ	4
	;]
SCREEN_BLANK:	equ	8


;================================================
;	q`l[N
;================================================
my_x:		equ	0	;b@@W
my_y:		equ	1
my_direc:	equ	2	;b@ړ

com_dead:	equ	3	;b@COMtO
com_x:		equ	4	;b@COMW
com_y:		equ	5
com_direc:	equ	6	;b@COMړ
com_rot:	equ	7	;b@COM]

com_check_count:equ	8	;b@COM؂芷JEg
com_dead_count:	equ	9	;b@COMSJEg
com_direc_step:	equ	10	;b@COM؂芷̃^C~O

line_speed:	equ	11	;b@Cړx
re_line_speed:	equ	12	;b@Cړx[hp

level:		equ	13	;b@x
over_flg:	equ	14	;b@Q[I[o[tO
stop_count_m:	equ	15	;b@@~JEg
stop_count_c:	equ	16	;b@COM~JEg

demo_flg:	equ	17	;b@ftO

flash:		equ	20	;b@Xe[^XXVtO
score:		equ	21	;p@XRA
hiscore:	equ	24	;p@nCXRA

anime_flg:	equ	35	;b@AjptO
anime_wait:	equ	36	;b@AjpEFCg
sound:		equ	37	;b@ʉON/OFFtO
key:		equ	40	;b@L[
keyf:		equ	41	;b@L[̓tO

val:		equ	42	;p@XRA\p[N

gx:		equ	50	;b@OtBbNp[N
gy:		equ	51	;b@OtBbNp[N
save_up:	equ	54	;p@[U[X^bNۑ
save_sp:	equ	57	;p@VXeX^bNۑ

work:		equ	60	;?@Gp



;================================================
;	CODE
;================================================
Start:
	pushu	imr

	pre	32h
	mv	[--u],(0ech)
	pre	32h
	mv	(0ech),0
	mv	(save_sp),s		;X^bN|C^ۑ

	mv	il,4
	sbcl	(bx),(bx)
	mv	a,[(0e6h)+8]
	mv	il,048h
	call	IocsCall		;\JnCZbg
	call	Cls

	call	Credit			;҃NWbg



	;e평
Init:
	mv	(level),1		;x1
	mvp	(hiscore),[HiScoreBuf]	;nCXRA[h
	mvp	(score),0		;XRAZbg
	mv	(keyf),0		;L[tOZbg

	call	Demo			;f



ReStart:
	mvw	(my_x),1*256+1		;@XW(1,1)
	mv	(my_direc),MY_DIREC_DEF	;@ړ

	call	InitValue
	call	InitCom
	call	InitMap
	call	Ready			;X^[g



	;C[`
Main:
 {
	call	Inkey			;L[ǂݏo

;	call	Anime			;Aj
	call	SetDirection		;؂芷
	call	MoveLine		;AGC̈ړ

	call	MapToScreen		;}bvXN[ɏ
	call	DispStatus		;Xe[^X\
	call	DispScreen		;XN[\

	call	Pause			;|[Y
	call	GameOver		;Q[I[o[
	test	(key),KEY_BASIC
	jrz	continue
 }



	;I
Basic:
	mv	s,(save_sp)		;X^bN|C^A
	and	[SCRN_CSR_Y],0		;sZbg

	call	Cls
	call	VerInfo			;o[W\
	pre	32h
	mv	(0ech),[u++]
	popu	imr
	rc
	retf



;------------------------------------------------
;	Q[Jn
;------------------------------------------------
Ready:
 {
	mv	(flash),1		;Xe[^XʍXV
	mv	ba,(my_x)		;@\
	mv	il,MARK_LINE
	call	PutMark

	mv	x,ComBuf		;COM\
	mv	(DI),MAX_COM
	{
		mv	ba,[x+1]
		mv	il,MARK_COM
		pushu	x
		call	PutMark
		popu	x
		mv	a,5
		add	x,a
		dec	(DI)
		jrnz	continue
	}
	call	MapToScreen
	{
		call	Inkey
		call	ChangeSe	;SE؂芷
		call	DispStatus
		call	Print_PUSH
		call	DispScreen

		test	(keyf),KEY_BASIC
		jrnz	Basic
		test	(keyf),KEY_SPACE
		jrz	continue
	}
	mv	x,Sound1
	jp	Se
 }



	;bZ[W\
Print_PUSH:
 {
	mv	x,Mes_PUSH	;PUSH [SPC] TO START!
	mv	y,ScreenBuf
	mv	il,94
	mv	ba,3*256+26
	jp	PutPattn_SET
 }



;------------------------------------------------
;	f\
;------------------------------------------------
Demo:
 {
	mv	(demo_flg),1
	mv	(sound),0
	call	InitValue		;eϐ
	call	InitCom			;G
	call	InitMap			;tB[h
	mv	(re_line_speed),DEMO_SPEED
	{
		call	Anime
		call	Inkey
		call	DemoLine
		call	DispStatus
		call	MapToScreen
		{
			test	(anime_flg),1
			jrz	break
			call	Print_DEMO	;fbZ[W
;			call	Print_PUSH
		}
		call	DispScreen

		call	JadgeWinLose
		test	(over_flg),WIN
		jrnz	Demo

		test	(keyf),KEY_BASIC
		jrnz	Basic
		test	(keyf),KEY_SPACE
		jrz	continue
	}
	mv	(demo_flg),0
	mv	(re_line_speed),LINE_SPEED_DEF
	mv	(sound),1
	mv	x,Sound5
	jp	Se
 }



	;Tu
DemoLine:
 {
	{
		dec	(line_speed)	;Xs[h
		jrz	break
		ret
	}
	mv	(line_speed),(re_line_speed)

	jp	MoveCom			;COMړ
 }



Print_DEMO:
 {
	mv	x,Mes_DEMO	;PAUSE
	mv	y,ScreenBuf
	mv	il,22
	mv	ba,0
	jp	PutPattn_SET
 }



;------------------------------------------------
;	eϐ
;------------------------------------------------
InitValue:
 {
	mv	(anime_flg),0		;AjptO
	mv	(anime_wait),ANIME_WAIT_DEF	;AjpEFCg
	mv	(com_dead_count),0		;COMSJEg
	mvw	(stop_count_m),0
	mv	(over_flg),0
	mv	(line_speed),(re_line_speed)
	mv	(flash),1
	ret
 }



;------------------------------------------------
;	|[Y
;------------------------------------------------
Pause:
 {
	{
		test	(keyf),KEY_SHIFT
		jrnz	break
		ret
	}
	mv	x,Sound1
	call	Se
	call	MapToScreen
	{
		call	Inkey
		call	Print_PAUSE
		call	ChangeSe	;SE؂芷
		call	DispStatus
		call	DispScreen
		test	(keyf),KEY_BASIC
		jpnz	Basic
		test	(keyf),KEY_SHIFT
		jrz	continue
	}
	mv	x,Sound1
	jp	Se
 }



	;bZ[W\
Print_PAUSE:
 {
	mv	x,Mes_PAUSE	;PAUSE
	mv	y,ScreenBuf
	mv	il,31
	mv	ba,3*256+89
	jp	PutPattn_SET
 }



;------------------------------------------------
;	Q[I[o[
;------------------------------------------------
GameOver:
 {
	{
		test	(over_flg),WIN | LOSE
		jrnz	break
		ret
	}
	mv	i,500
	call	Wait

	mv	(flash),ON
	call	Print_OVER		;WIN or LOSE@xAbv
	call	Print_PUSH
	{
		call	Inkey

		call	ChangeSe	;SE؂芷
		call	DispStatus
		call	DispScreen
		test	(keyf),KEY_BASIC
		jpnz	Basic
		test	(keyf),KEY_SPACE
		jrz	continue
	}
	mv	x,Sound1
	call	Se
	pops	i
	jp	ReStart
 }



	;bZ[W\xAbv
Print_OVER:
 {
	mv	x,Mes_You
	mv	y,ScreenBuf
	mv	il,26
	mv	ba,1*256+35
	call	PutPattn_SET
	{
		test	(over_flg),WIN
		jrz	break
		call	LevelUp		;xAbv
		call	Print_LEVEL

		mv	x,Sound5
		call	Se

		mv	x,Mes_WIN	;WIN!
		mv	y,ScreenBuf
		mv	il,31
		mv	ba,1*256+61
		jp	PutPattn_SET
	}
	mv	(level),1		;xZbg
	call	Print_LEVEL
	mv	(re_line_speed),LINE_SPEED_DEF
	call	Print_HISCORE		;nCXRA\

	mv	x,Sound4
	call	Se
	mv	x,Mes_LOSE		;LOSE..
	mv	y,ScreenBuf
	mv	il,35
	mv	ba,1*256+61
	jp	PutPattn_SET
 }



	;nCXRA\
Print_HiScore:
 {
	call	CmpScore

	mv	y,Bg_STATUS
	mv	x,Num_font_S	;tHg
	mv	ba,3*256+71	;(71,3)
	mvp	(val),(hiscore)
	jp	PutBcd6s
 }



	;nCXRAL^
CmpScore:
 {
	mvp	(work),(score)
	mvp	(work+3),(hiscore)
	call	CmpBCD6
	mvp	(hiscore),(work)
	mvp	[HiScoreBuf],(hiscore)
	mvp	(score),0
	ret
 }



	;x\
Print_level:
 {
	mv	y,Bg_STATUS
	mv	x,Num_font_B
	mv	ba,3*256+6	;(6,3)
	mv	(val),(level)
	jp	PutBcd1
 }



	;xAbv
LevelUp:
 {
	{
		inc	(level)
		cmp	(level),MAX_LEVEL
		jrc	break
		mv	(level),1
		mv	(re_line_speed),LINE_SPEED_DEF
		ret
	}
	sub	(re_line_speed),LEVEL_STEP
	ret
 }



;------------------------------------------------
;	ʉ؂芷
;------------------------------------------------
ChangeSe:
 {
	{
		test	(keyf),KEY_CCE
		jrnz	break
		ret
	}
	xor	(sound),1
	mv	x,Sound1
	call	Se
	mv	(flash),ON

	mv	x,Icon_Se
	mv	a,(sound)
	swap	a
	ror	a
	add	x,a
	mv	y,Bg_STATUS
	mv	il,8
	mv	ba,3*256+110
	jp	PutPattn_SET
 }



;------------------------------------------------
;	AjptOǗ
;------------------------------------------------
Anime:
 {
	{
		dec	(anime_wait)
		jrz	break
		ret
	}
	mv	(anime_wait),ANIME_WAIT_DEF
	xor	(anime_flg),1
	ret
 }



;------------------------------------------------
;	COM
;------------------------------------------------
InitCom:
 {
	call	Rnd
	and	a,3
	add	a,5			;ŏ̓JEg傫
	mv	(com_direc_step),a	;KȊԊuŕ؂芷

	mv	x,ComBuf
	mv	(DI),MAX_COM
	{
		mv	a,0		;StO
		mv	[x++],a
		{
			call	Rnd	;XW1-30
			and	a,15
			add	a,2
			add	a,a	;1}XԊu
			cmp	a,29
			jrnc	continue
			inc	a
			mv	[x++],a
		}
		mv	a,b
		and	a,7		;YW1-9
		inc	a
		mv	[x++],a
		call	Rnd
		and	a,2		;Ê݁iʑ΍j
		inc	a
		mv	[x++],a		;ړ

		call	Rnd		;]
		and	a,2		;1 or -1
		dec	a
		mv	[x++],a

		dec	(DI)
		jrnz	continue
	}
	ret
 }



;------------------------------------------------
;	؂芷
;------------------------------------------------
SetDirection:
 {
	{
		cmp	(stop_count_m),0
		jrz	break
		ret
	}
	{
		test	(keyf),KEY_4	;[4][6]ŕ]
		jrz	break
		dec	(my_direc)
		mv	x,Sound1
		call	Se
	}
	{
		test	(keyf),KEY_6
		jrz	break
		inc	(my_direc)
		mv	x,Sound1
		call	Se
	}
	and	(my_direc),3
	ret
 }



;------------------------------------------------
;	C
;------------------------------------------------
MoveLine:
 {
	{
		dec	(line_speed)	;Xs[h
		jrz	break
		ret
	}
	mv	(line_speed),(re_line_speed)

	call	MoveMyLine		;@ړ
	jp	MoveCom			;COMړ
 }



;------------------------------------------------
;	@ړ
;------------------------------------------------
MoveMyLine:
 {
	{
		cmp	(stop_count_m),0
		jrz	break
		dec	(stop_count_m)
		mv	x,Sound6
		jp	Se
;		ret
	}
	mvw	(work),(my_x)
	{
		cmp	(my_direc),UP
		jrnz	break
		dec	(work+1)
	}
	{
		cmp	(my_direc),DOWN
		jrnz	break
		inc	(work+1)
	}
	{
		cmp	(my_direc),RIGHT
		jrnz	break
		inc	(work)
	}
	{
		cmp	(my_direc),LEFT
		jrnz	break
		dec	(work)
	}
	{
		call	CheckMark	;Q`FbN
		jrnc	break
		call	JadgeWinLose
	}
	{
		cmp	(work+3),1		;
		jrnz	break
		mv	(stop_count_c),STOP_COUNT_DEF
		call	AddBonus		;{[iX_
		mv	x,Sound3
		call	Se
	}
	call	AddScore

	mv	il,MARK_LINE
	mv	ba,(my_x)
	call	PutMark

	mvw	(my_x),(work)
	mv	il,MARK_POINT
	mv	a,(my_direc)
	add	il,a
	mv	ba,(my_x)
 }



;------------------------------------------------
;	}bvɃLN^
;	:	ba	wxW
;		il	LN^ԍ
;------------------------------------------------
PutMark:
 {
	mv	x,FieldMap
	add	x,a
	mv	a,b
	and	a,8	;*32
	rol	a
	swap	a
	ex	a,b
	and	a,7
	swap	a
	rol	a
	add	x,ba
	mv	[x],il
	ret
 }



;------------------------------------------------
;	
;------------------------------------------------
JadgeWinLose:
 {
	mv	x,ComBuf
	mv	a,[x]
	mv	il,[x+5]
	add	a,il
	mv	il,[x+10]	;COM~3
	add	a,il
	{
		cmp	a,MAX_COM
		jrz	break
		mv	(over_flg),LOSE
		ret
	}
	mv	(over_flg),WIN
	ret
 }



;------------------------------------------------
;	COMړ
;------------------------------------------------
MoveCom:
 {
	{
		cmp	(stop_count_c),0
		jrz	break
		dec	(stop_count_c)
		ret
	}
	mv	x,ComBuf
	mv	(work+5),MAX_COM
	{
		mv	il,5
		mvl	(com_dead),[x++]
		{
			cmp	(com_dead),1
			jrz	break

			mv	(com_check_count),0
			pushu	x
			call	MoveCom_sub
			popu	x

			mv	il,5
			mvl	[x-5],(com_dead)
		}
		dec	(work+5)
		jrnz	continue
	}
	ret
 }



	;Tu
MoveCom_sub:
 {
	{
		cmp	(com_check_count),4
		jrnz	break
		inc	(com_dead)
		{
			inc	(com_dead_count)	;COMS@S
			cmp	(com_dead_count),3	;ʉ
			jrc	break
			mv	x,Sound5
			jp	Se
		}
		ret
	}
	mvw	(work),(com_x)
	{
		cmp	(com_direc),UP		;4ړ
		jrnz	break
		dec	(work+1)
	}
	{
		cmp	(com_direc),DOWN
		jrnz	break
		inc	(work+1)
	}
	{
		cmp	(com_direc),RIGHT
		jrnz	break
		inc	(work)
	}
	{
		cmp	(com_direc),LEFT
		jrnz	break
		dec	(work)
	}
	{
		{
			test	(com_check_count),1
			jrz	break
			xor	(com_rot),0ffh	;]]
			inc	(com_rot)
		}
		call	CheckMark		;Q`FbN
		jrnc	break
		inc	(com_check_count)
		mv	a,(com_rot)
		add	(com_direc),a
		and	(com_direc),3
		jr	MoveCom_sub
	}
	{
		cmp	(work+3),1		;
		jrnz	break
		mv	(stop_count_m),STOP_COUNT_DEF
		mv	x,Sound3
		call	Se
	}
	{
		dec	(com_direc_step)	;KȊԊuŕ؂芷
		jrnz	break
		call	Rnd
		and	a,3
		add	a,2
		mv	(com_direc_step),a	;̐؂芷Zbg
		mv	a,(com_rot)
		add	(com_direc),a
		and	(com_direc),3
		xor	(com_rot),0ffh		;]]
		inc	(com_rot)
		mv	(com_check_count),0
		jr	MoveCom_sub
	}
	mv	il,MARK_COM
	{
		cmp	(demo_flg),0
		jrz	break
		mv	il,MARK_LINE
	}
	mv	ba,(com_x)
	call	PutMark

	mvw	(com_x),(work)			;|C^[\
	mv	il,MARK_POINT
	mv	a,(com_direc)
	add	il,a
	mv	ba,(com_x)
	jp	PutMark
 }



;------------------------------------------------
;	Q`FbN
;	:	(work).w	XYW
;	o:	cy		0cȂ@1c
;		(work+3)	0cȂ@1c
;------------------------------------------------
CheckMark:
 {
	mv	(work+3),0
	mv	ba,(work)
	mv	x,FieldMap
	add	x,a
	mv	a,b
	and	a,8	;*32
	rol	a
	swap	a
	ex	a,b
	and	a,7
	swap	a
	rol	a
	add	x,ba

	mv	a,[x]
	{
		cmp	a,MARK_FLAG	;H
		jrnz	break
		inc	(work+3)
		rc
		ret
	}
	{
		test	a,0ffh		;ȊO
		jrz	break
		sc
		ret
	}
	rc
	ret
 }



;------------------------------------------------
;	}bvXN[ɕ`
;------------------------------------------------
MapToScreen:
 {
	mv	x,FieldMap+MAP_WIDTH+1
	mv	y,ScreenBuf
	mv	(SI),4
	{
		mv	(DI),MAP_WIDTH
		{
			pushu	y
			mv	y,ChrData
			mv	a,[x++]
			swap	a
			ror	a
			add	y,a

			mv	il,CHR_SIZE	;㔼
			mvl	(work),[y++]

			mv	y,ChrData+4
			mv	a,[x+MAP_WIDTH-1]
			swap	a
			ror	a
			add	y,a

			mv	il,CHR_SIZE	;
			mvl	(work+CHR_SIZE),[y++]

			or	(work),(work+CHR_SIZE)	;
			or	(work+1),(work+CHR_SIZE+1)
			or	(work+2),(work+CHR_SIZE+2)

			popu	y
			mv	il,CHR_SIZE
			mvl	[y++],(work)
			dec	(DI)
			jrnz	continue
		}
		mv	a,MAP_WIDTH
		add	x,a
		dec	(SI)
		jrnz	continue
	}
	ret
 }



;------------------------------------------------
;	tB[hubNZbgZbg
;------------------------------------------------
InitMap:
 {
	mv	x,FieldMap	;tB[h}bv̏
	mv	a,-1
	mv	i,MAP_WIDTH*MAP_HEIGHT
	{
		mv	[x++],a
		dec	i
		jrnz	continue
	}
	mv	x,FieldMap+MAP_WIDTH+1
	mv	(DI),MAP_HEIGHT-2
	inc	a
	{
		mv	il,MAP_WIDTH-2
		{
			mv	[x++],a
			dec	il
			jrnz	continue
		}
		inc	x
		inc	x
		dec	(DI)
		jrnz	continue
	}
	mv	(DI),MAX_BLOCK	;ubNZbg
	{
		call	Rnd
		and	a,127
		add	a,a	;1}XԊu
		mv	x,FieldMap+MAP_WIDTH+1+2
		add	x,a
		mv	a,MARK_BLOCK
		mv	[x],a
		dec	(DI)
		jrnz	continue
	}
	mv	(DI),MAX_FLAG	;Zbg
	{
		call	Rnd
		and	a,31
		add	a,a
		add	a,a
		add	a,a	;7}XԊu
		add	a,a
		mv	x,FieldMap+MAP_WIDTH+1
		add	x,a
		mv	a,MARK_FLAG
		mv	[x],a
		dec	(DI)
		jrnz	continue
	}
	ret
 }



;------------------------------------------------
;	Xe[^Xʕ\
;------------------------------------------------
DispStatus:
 {
	{
		cmp	(flash),0
		jrnz	break
		ret
	}
	dec	(flash)
	call	DispScore	;XRA\
	mv	x,Bg_STATUS
	jp	SendLcd_R
 }



;------------------------------------------------
;	XRA\@(18,24)
;------------------------------------------------
DispScore:
 {
	mv	y,Bg_STATUS
	mv	x,Num_font_B	;tHg
	mv	ba,3*256+18
	mvp	(val),(score)
	jp	PutBcd6
 }



;------------------------------------------------
;	XRAZ
;------------------------------------------------
AddScore:
 {
	mv	[--u],(over_flg)
	{
		call	JadgeWinLose
		mv	a,1		;1Xebv10_
		test	(over_flg),WIN
		jrz	break
		mv	a,3		;COMS@SƂPXebv30_
	}
	mv	il,3
	dadl	(score+2),a
	mv	x,Sound2
	call	Se

	mv	(over_flg),[u++]
	mv	(flash),1
	ret
 }



;------------------------------------------------
;	{[iXZ
;------------------------------------------------
AddBonus:
 {
	mv	a,BONUS
	mv	il,3
	dadl	(score+2),a

	mv	(flash),1
	ret
 }



;------------------------------------------------
;	abcUlr
;:	(work).p
;	(work+3).p  abcłU
;o:	(work).p@傫̐l
;j:	il
;------------------------------------------------
CmpBCD6:
 {
	{
		ex	(work),(work+2)
		ex	(work+3),(work+3+2)
		cmpp	(work),(work+3)
		jrnc	break
		ex	(work),(work+2)
		ex	(work+3),(work+3+2)

		mvp	(work),(work+3)
		ret
	}
	ex	(work),(work+2)
	ex	(work+3),(work+3+2)
	ret
 }



;------------------------------------------------
;	҃NWbg
;------------------------------------------------
Credit:
 {
	mv	x,Font_CHOI
	mvp	(work),12*65536+88*256+64
	call	GPrint

	mv	i,450
	call	wait
	jp	Cls
 }



;------------------------------------------------
;	XN[obt@\
;------------------------------------------------
DispScreen:
 {
	mv	x,ScreenBuf
	jp	SendLcd_L
 }



;------------------------------------------------
;	o[W
;------------------------------------------------
VerInfo:
 {
	mv	il,04h
	pre	32h
	mvw	(CX),0
	mv	x,v0
	mv	y,v1-v0
	jp	FcsCall
v0:
	db	'LIGHT CYCLE E500 ver.1.01',13,10
	db	'   by choikyun 2006-02-27',13,10
v1:
 }



;------------------------------------------------
;	XN[obt@kbcb]iʁj
;	:	x  XN[obt@
;	o:	Ȃ
;	j:	x,y,i,ba
;------------------------------------------------
SendLcd_L:
 {
	mv	a,0b8h
	{
		mv	[2000h],a
		mv	b,a
		mv	il,40h
		mv	[2000h],il

		mv	il,64
		mv	y,2006h
		{
			mv	a,[x++]
			mv	[y],a
			dec	il
			jrnz	continue
		}
		mv	y,200ah
		mv	il,56
		{
			mv	a,[x++]
			mv	[y],a
			dec	il
			jrnz	continue
		}
		mv	a,8	;]Whbg
		add	x,a

		mv	a,b
		inc	a
		cmp	a,0bch
		jrnz	continue
	}
	ret
 }



;------------------------------------------------
;	XN[obt@kbcb](E)
;	:	x@XN[obt@
;	o:	Ȃ
;	j:	ba,i,x,y
;------------------------------------------------
SendLcd_R:
 {
	mv	a,0b8h+4
	{
		mv	[2008h],a
		mv	b,a
		mv	a,56
		add	x,a
		mv	il,40h
		mv	[2008h],il

		mv	il,56
		mv	y,200ah
		{
			mv	a,[--x]
			mv	[y],a
			dec	il
			jrnz	continue
		}
		mv	a,120
		add	x,a
		mv	a,b
		mv	[2004h],a
		mv	il,40h
		mv	[2004h],il
		mv	y,2006h
		mv	il,64
		{
			mv	a,[--x]
			mv	[y],a
			dec	il
			jrnz	continue
		}
		mv	a,64+8
		add	x,a
		mv	a,b
		inc	a
		cmp	a,0bch+4
		jrnz	continue
	}
	ret
 }



;------------------------------------------------
;	
;	:	Ȃ
;	o:	(key).b		L[͒1
;				b0=[CCE] b1=[SFT] b2=[BAS] b3=[SPC]
;				b4=[6] b5=[4] b6=[2] b7=[8]
;		(keyf).b	L[͍ŏ1ie͏ɓj
;	j:	a
;------------------------------------------------
InKey:
 {
	mvw	(KO),0100_0000b		;[8]and[2]Zbg
	mv	a,(key)
	xor	a,0ffh
	mv	(keyf),a
	mv	a,(KI)			;(KO)(KI)ǂފԂ݂
	ror	a
	swap	a
	and	a,1000_0000b		;[8]=b7
	mv	(key),a

	mv	a,(KI)
	mv	(KO),0010_0000b		;[4]Zbg
	and	a,0100_0000b		;[2]=b6
	or	(key),a

	mv	a,(KI)
	mv	(KO),1000_0000b		;[6],[CCE]Zbg
	and	a,0010_0000b		;[4]=b5
	or	(key),a

	mv	a,(KI)
	ror	a
	and	a,0001_0000b		;[6]=b4
	or	(key),a

	mv	a,(KI)
	mv	(KO),0000_0100b		;[SPC]Zbg
	and	a,0000_0001b		;[CCE]=b0
	or	(key),a

	mv	a,(KI)
	mv	(KO),0000_0001b		;[BAS],[SHIFT]Zbg
	rol	a
	swap	a
	and	a,0000_1000b		;[SPC]=b3
	or	(key),a

	mv	a,(KI)
	rol	a
	rol	a
	swap	a
	and	a,0000_0100b		;[BAS]=b2
	or	(key),a

	mv	a,(KI)
	ror	a
	swap	a
	and	a,0000_0010b		;[SHIFT]=b1
	or	(key),a

	and	(keyf),(key)
	ret
 }



;------------------------------------------------
;	W~hbgp^[`
;	:	ba	wxW(0-119,0-3)
;		il	w](1-119)
;		x	LN^
;		y	݃obt@
;	o:	Ȃ
;	j:	x,y,il,ba
;------------------------------------------------
PutPattn_SET:
 {
	pushu	il
	mv	il,SCREEN_WIDTH
	add	y,a
	{
		mv	a,b
		cmp	a,0
		jrz	break
		{
			add	y,il
			dec	a
			jrnz	continue
		}
	}
	popu	il
	{
		mv	a,[x++]		;XN[
		mv	[y++],a
		dec	il
		jrnz	continue
	}
	ret
 }



;--------------------------------------
;	foqhms IOCS
;	:	(work)		tHg̒
;		(work+1)	wW
;		(work+2)	xW
;		x		tHg
;	o:	Ȃ
;	j:	x,y,il,(work)
;-------------------------------------
GPrint:
 {
	mvw	(CX),0
	{
		mv	a,[x++]
		pushu	x
		mv	il,(work+1)
		mv	x,il
		mv	il,(work+2)
		mv	y,il
		mv	il,4ah

		call	IocsCall
		inc	(work+1)
		popu	x
		dec	(work)
		jrnz	continue
	}
	ret
 }



;--------------------------------------
;	
;	:	Ȃ
;	o:	ba@065535
;	j:	y,i,ba
;--------------------------------------
Rnd:
 {
	mv	y,0e0000h
	mv	i,[(0e6h)+14]
	pushu	i
	popu	ba
	add	i,i
	add	i,i
	add	i,ba
	inc	i
	mv	[(0e6h)+14],i
	add	y,i
	mv	ba,[y]
	add	ba,i
	ret
 }

;------------------------------------------------
;	abc1l\iSETjtHgp
;	:	x		tHg(8~7hbg)
;		(val)		abc1
;		ba		\wxW 0-119 0-3
;		y		݃obt@
;	o:	Ȃ
;	j:	il,ba,(DI)
;------------------------------------------------
PutBcd1:
 {
	mv	(DI),ba
	mv	a,(val)
	swap	a
	jp	PutBcdSub
 }



;------------------------------------------------
;	abc6l\iSETjtHgp
;	:	x		tHg(8~7hbg)
;		(val).p		abc6
;		ba		\wxW 0-119 0-3
;		y		݃obt@
;	o:	Ȃ
;	j:	il,ba,(DI)
;------------------------------------------------
PutBcd6:
 {
	mv	(DI),ba

	mv	a,(val)
	call	PutBcdSub
	call	PutBcdSub
	mv	a,(val+1)
	call	PutBcdSub
	call	PutBcdSub
	mv	a,(val+2)
	call	PutBcdSub
 }


	;Tu
PutBcdSub:
 {
	pushu	x
	pushu	y

	swap	a
	pushu	a
	and	a,0fh
	swap	a
	ror	a
	add	x,a

	mv	ba,(DI)
	mv	il,7
	call	PutPattn_SET

	popu	a
	popu	y
	popu	x
	add	(DI),7
	ret
 }



;------------------------------------------------
;	abc6l\iSETj@tHgp
;	:	x		tHg(8~5hbg)
;		(val).p		abc6
;		ba		\wxW 0-119 0-3
;		y		݃obt@
;	o:	Ȃ
;	j:	il,ba,(DI)
;------------------------------------------------
PutBcd6s:
 {
	mv	(DI),ba

	mv	a,(val)
	call	PutBcdSubs
	call	PutBcdSubs
	mv	a,(val+1)
	call	PutBcdSubs
	call	PutBcdSubs
	mv	a,(val+2)
	call	PutBcdSubs
 }


	;Tu
PutBcdSubs:
 {
	pushu	x
	pushu	y

	swap	a
	pushu	a
	and	a,0fh
	swap	a
	ror	a
	add	x,a

	mv	ba,(DI)
	mv	il,5
	call	PutPattn_SET

	popu	a
	popu	y
	popu	x
	add	(DI),5
	ret
 }



;------------------------------------------------
;	ʉ
;		x@ʉ
;	o	Ȃ
;	j	x,ba,(SI),(DI)
;------------------------------------------------
Se:
 {
	{
		test	(sound),ON
		jrz	break

		mv	(SI),2
		{
			mv	ba,[x++]
			mvw	(DI),[x++]
			call	SeSub
			dec	(SI)
			jrnz	continue
		}
	}
	ret
 }

SeSub:
 {
	{
		xor	(0fdh),010h
		mv	i,(DI)
		wait
		dec	ba
		jrnz	continue
	}
	ret
 }



;------------------------------------------------
;	PFpEFCg
;	:	i	EFCg
;	o:Ȃ
;	j:	a,i
;------------------------------------------------
Wait:
 {
	mv	a,255
	{
		dec	a
		jrnz	continue

		dec	i
		jrnz	Wait
	}
	ret
 }



;------------------------------------------------
;	ʃNA
;	:	Ȃ
;	o:	Ȃ
;	j:	il
;------------------------------------------------
Cls:
 {
	mv	il,051h
 }



;------------------------------------------------
;	hnbrR[
;------------------------------------------------
IocsCall:
 {
	pre	32h
	mv	(0ech),0bbh
	callf	SYS_IOCS
	pre	32h
	mv	(0ech),0
	ret
 }



;------------------------------------------------
;	ebrR[
;------------------------------------------------
FcsCall:
 {
	pre	32h
	mv	(0ech),0bbh
	callf	SYS_FCS
	pre	32h
	mv	(0ech),0
	ret
 }



;================================================
;	DATA
;================================================
ChrData:
	db	0,0,0,0			;
	db	0,0,0,0
	db	007h,007h,007h,0	;@
	db	070h,070h,070h,0
	db	007h,005h,007h,0	;COM1
	db	070h,050h,070h,0
	db	002h,007h,002h,0	;COM2
	db	020h,070h,020h,0
	db	005H,002H,005H,0	;ubN
	db	050h,020h,050h,0
	db	007h,003h,003h,0	;
	db	070h,030h,030h,0

	db	006H,005H,006H,0	;|C^[@UP
	db	060h,050h,060h,0
	db	007H,005H,002H,0	;RIGHT
	db	070h,050h,020h,0
	db	003H,005H,003H,0	;DOWN
	db	030h,050h,030h,0
	db	002H,005H,007H,0	;LEFT
	db	020h,050h,070h,0

	;Xe[^Xʂ̃ACR
	;SE
Icon_SE:
	db	000H,000H,022H,014H,008H,014H,022H,000H	;OFF
	db	01CH,01CH,03EH,03EH,000H,022H,049H,008H	;ON



	;bZ[W
Mes_PAUSE:
    ;31*1=31 bytesikj
    DB 000H,07EH,07EH,012H,01EH,01EH,000H,07EH	;|[Y
    DB 07EH,012H,07EH,07EH,000H,07EH,07EH,040H
    DB 07EH,07EH,000H,04EH,04EH,04AH,07AH,07AH
    DB 000H,07EH,07EH,04AH,04AH,04AH,000H
Mes_PUSH:
    ;94*1=94 bytesikj
    DB 07FH,041H,075H,015H,01BH,00EH,03FH,061H	;PUSH[SPC]TOSTART!
    DB 05FH,05FH,061H,03FH,06EH,05BH,055H,055H
    DB 06DH,03BH,07FH,041H,077H,077H,041H,07FH
    DB 000H,03EH,07FH,07FH,051H,055H,055H,045H
    DB 07FH,041H,075H,075H,071H,07FH,041H,05DH
    DB 05DH,05DH,07FH,07FH,03EH,000H,007H,07DH
    DB 041H,07DH,007H,03EH,063H,05DH,05DH,063H
    DB 03EH,000H,06EH,05BH,055H,055H,06DH,03BH
    DB 007H,07DH,041H,07DH,007H,07EH,043H,06DH
    DB 06DH,043H,07EH,07FH,041H,06DH,06DH,053H
    DB 07EH,007H,07DH,041H,07DH,007H,000H,07FH
    DB 051H,07FH,07FH,051H,07FH,000H
Mes_YOU:
	;26
    DB 000H,00FH,019H,071H,047H,047H,071H,019H	;YOU
    DB 00FH,03EH,063H,041H,05DH,05DH,041H,063H
    DB 03EH,03FH,061H,041H,05FH,05FH,041H,061H
    DB 03FH,000H
Mes_WIN:
	;31
    DB 03FH,061H,041H,05FH,042H,05FH,041H,061H	;WIN!!
    DB 03FH,077H,05DH,041H,041H,05DH,077H,07FH
    DB 041H,041H,073H,066H,04FH,041H,041H,07FH
    DB 051H,051H,07FH,051H,051H,07FH,000H
Mes_LOSE:
	;35
    DB 07FH,041H,041H,05FH,050H,050H,070H,03EH	;LOSE..
    DB 063H,041H,05DH,05DH,041H,063H,03EH,07EH
    DB 05BH,051H,055H,055H,045H,06DH,03FH,07FH
    DB 041H,041H,055H,055H,05DH,077H,050H,070H
    DB 050H,070H,000H
Mes_DEMO:
	;22
    DB 07FH,041H,05DH,05DH,063H,07FH,041H,055H	;DEMO
    DB 055H,07FH,041H,07BH,077H,07BH,041H,07FH
    DB 063H,05DH,05DH,063H,07FH,000H


	;tHg
Num_font_S:
	db	03EH,022H,022H,03EH,000H,0,0,0;@0-9
	db	000H,000H,03EH,000H,000H,0,0,0
	db	03AH,02AH,02AH,02EH,000H,0,0,0
	db	02AH,02AH,02AH,03EH,000H,0,0,0
	db	01EH,010H,03EH,010H,000H,0,0,0
	db	02EH,02AH,02AH,03AH,000H,0,0,0
	db	03EH,02AH,02AH,03AH,000H,0,0,0
	db	002H,002H,002H,03EH,000H,0,0,0
	db	03EH,02AH,02AH,03EH,000H,0,0,0
	db	02EH,02AH,02AH,03EH,000H,0,0,0
Num_font_B:
	db	07FH,07FH,041H,041H,07FH,07FH,000H,0;@0-9
	db	000H,000H,07FH,07FH,000H,000H,000H,0
	db	079H,079H,049H,049H,04FH,04FH,000H,0
	db	049H,049H,049H,049H,07FH,07FH,000H,0
	db	01FH,01FH,010H,07FH,07FH,010H,000H,0
	db	04FH,04FH,049H,049H,079H,079H,000H,0
	db	07FH,07FH,049H,049H,079H,079H,000H,0
	db	001H,001H,079H,07DH,007H,003H,000H,0
	db	07FH,07FH,049H,049H,07FH,07FH,000H,0
	db	04FH,04FH,049H,049H,07FH,07FH,000H,0



	;E^Cg^Xe[^X
Bg_STATUS:
    ;128*4=512 bytesikj
    DB 0DBH,000H,09FH,0F1H,005H,0FDH,005H,0F1H
    DB 0FFH,0F8H,0F8H,0F8H,0FFH,0C1H,01DH,0F5H
    DB 01DH,0C1H,003H,0FAH,00AH,0CAH,08AH,0AAH
    DB 0ABH,089H,09DH,09DH,01DH,0C1H,005H,0FDH
    DB 085H,0B1H,0BFH,0BFH,081H,09DH,0F5H,01DH
    DB 0C1H,0DDH,0C9H,0E9H,0EBH,0EAH,00AH,0FAH
    DB 00AH,0EBH,0C9H,0DDH,0DDH,0DDH,001H,0BFH
    DB 09CH,0C4H,074H,0C4H,09CH,0BCH,03EH,002H
    DB 0FAH,00AH,0EAH,0EAH,0EBH,0C9H,0DDH,0DDH
    DB 0DDH,0C1H,0C7H,0D3H,0C9H,095H,021H,04FH
    DB 09EH,04FH,021H,09DH,0D5H,0DDH,001H,0FBH
    DB 00AH,0EAH,0EAH,0EBH,0C9H,0DDH,0DDH,0DDH
    DB 0C1H,005H,0FDH,005H,0F1H,0FFH,0F8H,0F8H
    DB 0F8H,0F8H,01EH,0C2H,07AH,0CAH,08AH,0AAH
    DB 0AAH,08AH,0CBH,009H,0DDH,0C1H,0FFH,0F0H
    DB 000H,000H,000H,000H,000H,000H,000H,000H
    DB 0B6H,000H,01FH,03FH,020H,02FH,028H,02BH
    DB 02BH,049H,05DH,05DH,05DH,041H,050H,05FH
    DB 050H,047H,060H,02FH,028H,029H,028H,02AH
    DB 02AH,02AH,028H,02FH,060H,041H,05CH,05FH
    DB 05CH,040H,07EH,07EH,046H,050H,05FH,050H
    DB 047H,07FH,03FH,03FH,07FH,041H,05CH,057H
    DB 05CH,041H,07FH,00FH,00FH,00FH,00EH,00EH
    DB 01CH,011H,017H,011H,01CH,01EH,03EH,020H
    DB 02FH,028H,02BH,02BH,02BH,02BH,06BH,049H
    DB 05DH,041H,07FH,03FH,03FH,07FH,041H,05CH
    DB 05FH,05CH,041H,07FH,03FH,03FH,020H,02FH
    DB 028H,02BH,02BH,02BH,02BH,06BH,049H,05DH
    DB 041H,060H,02FH,028H,02BH,06BH,049H,05DH
    DB 055H,05DH,040H,061H,02FH,029H,028H,02AH
    DB 06AH,048H,05DH,05CH,05DH,041H,07FH,003H
    DB 000H,000H,000H,000H,000H,000H,000H,000H
    DB 06DH,000H,014H,008H,014H,008H,014H,008H
    DB 014H,008H,014H,008H,014H,008H,014H,008H
    DB 014H,008H,014H,000H,000H,000H,00AH,00AH
    DB 00AH,00AH,03AH,000H,000H,000H,004H,004H
    DB 004H,03CH,002H,002H,002H,000H,000H,000H
    DB 03EH,008H,008H,008H,000H,000H,000H,004H
    DB 01EH,004H,004H,03EH,004H,000H,000H,000H
    DB 004H,004H,004H,03CH,002H,002H,002H,000H
    DB 000H,000H,00EH,002H,002H,002H,03EH,000H
    DB 000H,000H,03EH,000H,03EH,020H,020H,000H
    DB 000H,03EH,02AH,02AH,02AH,000H,02EH,02AH
    DB 02AH,03AH,000H,03EH,022H,022H,03EH,000H
    DB 03EH,022H,022H,03EH,000H,000H,000H,014H
    DB 008H,014H,008H,014H,008H,014H,008H,014H
    DB 008H,014H,008H,014H,008H,014H,008H,014H
    DB 000H,000H,000H,000H,000H,000H,000H,000H
    DB 0DBH,000H,000H,000H,000H,000H,000H,000H
    DB 041H,07FH,07FH,040H,000H,000H,000H,000H
    DB 000H,000H,07FH,07FH,041H,041H,07FH,07FH
    DB 000H,07FH,07FH,041H,041H,07FH,07FH,000H
    DB 07FH,07FH,041H,041H,07FH,07FH,000H,07FH
    DB 07FH,041H,041H,07FH,07FH,000H,07FH,07FH
    DB 041H,041H,07FH,07FH,000H,07FH,07FH,041H
    DB 041H,07FH,07FH,000H,07FH,07FH,041H,041H
    DB 07FH,07FH,000H,000H,000H,000H,000H,03EH
    DB 022H,022H,03EH,000H,03EH,022H,022H,03EH
    DB 000H,03EH,022H,022H,03EH,000H,03EH,022H
    DB 022H,03EH,000H,03EH,022H,022H,03EH,000H
    DB 03EH,022H,022H,03EH,000H,03EH,022H,022H
    DB 03EH,000H,000H,000H,000H,000H,01CH,01CH
    DB 03EH,03EH,000H,022H,049H,008H,000H,000H
    DB 000H,000H,000H,000H,000H,000H,000H,000H



	;҃NWbg
Font_CHOI:
    ;64*1=64 bytesikj
    DB 074H,054H,05CH,000H,07CH,044H,07CH,000H
    DB 07CH,044H,07CH,000H,07CH,054H,074H,000H
    DB 000H,038H,044H,044H,044H,000H,07CH,010H
    DB 010H,010H,07CH,000H,038H,044H,044H,044H
    DB 038H,000H,044H,07CH,044H,000H,010H,038H
    DB 010H,000H,07CH,010H,028H,044H,000H,004H
    DB 008H,070H,008H,004H,000H,03CH,040H,040H
    DB 040H,03CH,000H,07CH,008H,010H,020H,07CH



	;ʉ
	;,F
Sound1:
	dw	8,600,15,700	;؂芷
Sound2:
	dw	2,300,2,320	;Cړ
Sound3:
	dw	20,450,40,600	;ACe
Sound4:
	dw	40,800,80,1200	;
Sound5:
	dw	60,550,120,450	;
Sound6:
	dw	4,340,4,380	;Xgbv



;================================================
;	WORK
;================================================
HiScoreBuf:	ds	3		;nCXRAۑ
ComBuf:		ds	5*MAX_COM	;GFtO,XYW,ړ,]tO
	;tB[h}bv
FieldMap:	ds	MAP_WIDTH*MAP_HEIGHT
	;XN[obt@
ScreenBuf:	ds	SCREEN_WIDTH*SCREEN_HEIGHT



	end
